'use common library
ExecuteGlobal CreateObject("Scripting.FileSystemObject").OpenTextFile( left( WScript.ScriptFullName , len (WScript.ScriptFullName) -len( WScript.ScriptName ) ) & "\vb-script-library.vbs",1).ReadAll()
InitScript("Certificate Installation Script")

'global variables 
DIM IISAccount, rootstore

'the certificate path 
function GetCertPath( )
	GetCertPath= fso.GetFolder(GetScriptPath).ParentFolder & "\Certificates\"
end function

' test for CAPICOM library.
sub VerifyCAPICOM()
dim store
    on error resume next
    set store = CreateObject("Capicom.Store")
    if err.number <> 0 then
        if err.number <> 0 then
            logerror "It would appear that the CAPICOM library is not installed." 
            logerror "Please run the install-capicom.bat script to install CAPICOM." 
            finished 
        end if
    end if
end sub

sub VerifyIIS()
    on error resume next
    dim iis_installed

    iis_installed = wso.RegRead( "HKLM\Software\Microsoft\InetStp\PathWWWRoot")
    if err.number <> 0 OR iis_installed = "" then
         wso.popup( "It would appear that IIS is not installed." &vbcrlf& "Please install IIS prior to installing the PRESTO Starter Kit samples." )
         logerror "It would appear that IIS is not installed." &vbcrlf& "Please install IIS prior to installing the PRESTO Starter Kit samples." 
        finished 
    end if
end sub


REM SCRIPT STARTS HERE
On Error Resume Next
VerifyCAPICOM 
VerifyIIS

dim filename
IISAccount = GetIISUser()

if wso.popup( "Note: this script installs the Certificates for the PRESTO Starter Kit samples."&vbcrlf&"It modifies ACLs on it's own certificate's private key files, in order that ASP.NET running under IIS can access the files. "&vbcrlf&vbcrlf&"This process could take a few minutes"&vbcrlf&vbcrlf&"WARNING: *These certificates are for testing only and should not be installed on a production machine*" , , "Note" , 49 ) = 2 then 
    logerror "Installation cancelled at user request"
    finished
end if

DeleteCertificate "root", "localMachine" , "PRESTO Test Root CA"

' install root CA cert
InstallCertificate "root", "localMachine" , GetCertPath & "ca.presto.test.pfx"

' install leaf certs
DeleteCertificate "My", "localMachine" , "PRESTO Source Application" 
DeleteCertificate "My", "localMachine" , "PRESTO Sender Proxy" 
DeleteCertificate "My", "localMachine" , "PRESTO Receiver Proxy" 
DeleteCertificate "My", "localMachine" , "PRESTO Target Application" 

log "Installing Source Application Certificate from " & GetCertPath & "source.presto.test.pfx"
InstallCertificate "My", "localMachine" , GetCertPath & "source.presto.test.pfx"
filename = GetKeyStoreFile( "My","localMachine", "PRESTO Source Application" )
AddReadACL filename , IISAccount 

log "Installing Sender Proxy Certificate from " & GetCertPath & "sender.presto.test.pfx"
InstallCertificate "My", "localMachine" , GetCertPath & "sender.presto.test.pfx"
filename = GetKeyStoreFile( "My","localMachine", "PRESTO Sender Proxy" )
AddReadACL filename , IISAccount 

log "Installing Receiver Proxy Certificate from " & GetCertPath & "receiver.presto.test.pfx"
InstallCertificate "My", "localMachine" , GetCertPath & "receiver.presto.test.pfx"
filename = GetKeyStoreFile( "My","localMachine", "PRESTO Receiver Proxy" )
AddReadACL filename , IISAccount 

log "Installing Target Application Certificate from " & GetCertPath & "target.presto.test.pfx"
InstallCertificate "My", "localMachine" , GetCertPath & "target.presto.test.pfx"
filename = GetKeyStoreFile( "My","localMachine", "PRESTO Target Application" )
AddReadACL filename , IISAccount 

finished